#!/usr/bin/perl
use strict;
use utf8;
use Encode;
use Encode::Guess qw/euc-jp shift-jis utf8/;

#$/ = "\r";
#Record SeparatorをCRに、LFにしたければコメントアウト・・と
#思っていたが、なぜか\rにすると改行の近くで変換ミスする。
#原因不明。知っている人は教えてください。

our $unreadable_count = 0;
our $nottext_count = 0;
our $countfile = 0;
our $countreplace = 0;
our (@findlist,@replacelist,@regexflag);
our $replace_mode = 'normal';
our $list_char_code;

main ();

sub main {
	my (@paralist,$swich,$readfile);
	@paralist = @ARGV;
	$swich = "";
	$swich = shift (@paralist);
	$readfile = shift(@paralist);
	#↑バグありだけど、面倒くさいので放置
	
	if ($swich eq "-l"){&readlist($readfile);}
	else{die ("rakudax.pl -l [replacelist] file01 file02 .....\n");}

	&search1(@paralist);

	my $msg = '合計 『'.$countfile.'』個のファイル中、『'."$countreplace".'』個所を置換しました。';

	if ($unreadable_count != 0){
		$msg .= "\n".$unreadable_count."個のファイルで文字コード判定に失敗しました。";
	}
	if ($nottext_count != 0){
		$msg .= "\n".$nottext_count."個のファイルはテキストファイルではないと判断しました。";
	}
	
	utf8::encode($msg);
	print $msg;
}

#ファイルの処理ルーチン
sub search1 {
	my $file;
	my @filelist = @_;
	foreach $file(@filelist){
		if (-d $file) {&search2($file);}
		#OS Xの不要なファイルは　nextする
		elsif (not -f $file){next;}
		elsif ($file eq ".") { next; }
		elsif ($file eq "..") { next; }
		elsif ($file eq ".DS_Store") { next; }
		elsif ($file eq "Icon?") { next; }
		#飛ばすファイル拡張子 -> rtfはテキストに判定されてしまう 処理の高速化のため思いつくままに拡張子指定
		elsif ($file =~ m/\.(rtf|rtfd|jpg|jpeg|gif|png|pdf|ppt|xls|sit|zip|mp3|mov|wmv|rm|avi)$/i)  {$nottext_count++;next; }
		#処理するファイル拡張子 -> 下記の拡張子はテキストと判定
		elsif ($file =~ m/\.(txt|html|htm|pl|csv)$/i) {&replace($file) ;}
		#テキストファイル判別ルーチン↓完璧ではない
		elsif (is_text($file)) {&replace($file) ;}
		else {next;}
	}
}

#ディレクトリの処理ルーチン、ディレクトリを開いてファイルを浚う
sub search2 {
	my $dir = $_[0];
	my (@filelist, $file, $filename, $filetype);

	opendir(DIR, $dir);
	@filelist = readdir(DIR);
	closedir(DIR);
	
	foreach $file (@filelist) {
		if ($file eq ".") { next; }
		elsif ($file eq "..") { next; }
		elsif ($file eq ".DS_Store") { next; }
		elsif ($file eq "Icon?") { next; }
		elsif ($file =~ m/\.(rtf|rtfd|jpg|jpeg|gif|png|pdf|ppt|xls|sit|zip|mp3|aif|wav|tiff|mov|wmv|rm|avi)$/i)  {$nottext_count++;next; }
		
		$filename = "$dir/$file";
		
		if (-d $filename) {&search2($filename);}
		elsif ($file =~ m/\.(txt|html|htm|pl|csv)$/i) {&replace($filename) ;}
		elsif (is_text($filename)) {&replace($filename) ;}
		else {next;}
	}
}

#パターンマッチ置換のサブルーチン

sub replace {
	my $file = $_[0];
	my ($a,$count,$find,$replace,$num,$buf,$guess,$char);

	#replace_modeはリストファイルの読み込み時、１行目にrawの記述があれば"raw"
	if ($replace_mode eq "normal"){
		open FH,"<","$file" or die ("$file open error! sorry");
		read (FH, $buf,200);
		close FH;
		
		#文字コード判定、判定付かなければ飛ばす
		$guess = Encode::Guess::guess_encoding($buf);
		unless (ref $guess){$unreadable_count++;last;}
		
		#shift_jisはcp932にする仕様。これをやらないとマル１などで変換エラー
		if ($guess->name eq 'shiftjis'){$guess = "cp932";}
		else {$guess = $guess->name;}
		
		#UTFに変換して読み込み
		open IN, "<:encoding($guess)", $file or die ("$file open error! sorry");
		my @IN = <IN>;
		close IN;
		#置換ファイル数
		$countfile++;

		#ascii→日本語変換の場合を考慮、asciiの場合はリストの文字コードで書き込む
		if ($guess ne "ascii"){open OUT, ">:encoding($guess)", $file;}
		else {open OUT, ">:encoding($list_char_code)",$file;}
		
		for (@IN){
			$count = 0;
			foreach $a(@findlist){
				$find = $findlist[$count];
				$replace = $replacelist[$count];

				#regexフラグが倒れてると、$findはquotemetaされている。
				if ($regexflag[$count] eq "regex"){
					$num = ($_ =~ s/$find/qq("$replace")/eeig);
				}else{
					$num = ($_ =~ s/$find/$replace/gi);
				}
				
				$count++;
				$countreplace += $num;
			}
			print OUT "$_";
		}
	}
	
	#rawモードなら、UTF変換せずに読み込む。文字コード指定で変換する場合や、ユーザ設定の外字変換などの場合
	elsif ($replace_mode eq "raw"){
		open IN,"<","$file" or die ("$file open error! sorry");
		my @IN = <IN>;
		close(IN);
		$countfile++;

		open OUT, ">","$file" or die ("$file open error! sorry");;
		for (@IN){
			$count = 0;
			foreach $a(@findlist){
				$find = $findlist[$count];
				$replace = $replacelist[$count];
				if ($regexflag[$count] eq "regex"){
					$num = ($_ =~ s/$find/qq("$replace")/eeig);
				}else{
					$num = ($_ =~ s/$find/$replace/gi);
				}
				$count++;
				$countreplace += $num;
			}
		print OUT "$_";
		}
	}
	close(OUT);
}


#置換リストを読み込むサブルーチン
sub readlist {
	my $text_code = "";
	my $count = 0;
	my $file_content = "";
	my @FH;
	
	open FH,"<","$_[0]" or die("replace list open error");
	my $file_content = join('',<FH>);
	
	#標準のtext editがLFで書き出す。Macの標準改行コードはなんじゃぁー！！・・LFなの？
	#しょうがないので、CRLFにも対応、record separaterを弄ったら変換のミスがでたので。
	if ($file_content =~ m/\x0D\x0A/){@FH = split /\x0D\x0A/,$file_content;}
	elsif ($file_content =~ m/\x0D/){@FH = split /\x0D/,$file_content;}
	else {@FH = split /\x0A/,$file_content;}

	close (FH);
	
	
	#１行目がtab抜きなら、文字コードが書いてあると推測して
	unless ($FH[0] =~ m/\t/){
		if ($FH[0] =~ m/shit.?jis/i){
			$text_code = "cp932";
		}
		elsif ($FH[0] =~ m/euc/i){
			$text_code = "euc-jp";
		}
		elsif ($FH[0] =~ m/7bit.?jis/i){
			$text_code = "7bit-jis";
		}
		elsif ($FH[0] =~ m/utf.?8/i){
			$text_code = "utf8";
		}
		elsif ($FH[0] =~ m/UTF.?16/i){
			$text_code = "UTF-16";
		}
		elsif ($FH[0] =~ m/ascii/i){
			$text_code = "ascii";
		}
		elsif ($FH[0] =~ m/raw/i){
			$replace_mode = "raw";
			$text_code = "raw";
		}
	}
	
	#もし判定できてなければEncode::Guessで判定、失敗したらrawモードになりバイナリとして読む(UTF8変換しない)
	if ($text_code eq ""){
		my $guess = Encode::Guess::guess_encoding(join "\n",@FH);

		unless (ref $guess){
			$replace_mode = "raw";
			$text_code = "raw";
		}
		elsif ($guess->name eq 'shiftjis'){$text_code = "cp932";}
		else {$text_code = $guess->name;}

	}
	#グローバル変数
	$list_char_code = $text_code;
	
	for (@FH){
		unless (/\t/){next;}
		unless ($text_code eq "raw"){$_ = Encode::decode($text_code, $_);}

		chomp $_;
		s/(\r|\n)$//g;
		
		#読み込んだ文字をリストへ、正規表現フラグが無ければquotemetaする
		($findlist[$count],$replacelist[$count],$regexflag[$count]) = split /\t/,$_;
		$regexflag[$count] = ($regexflag[$count] ? $regexflag[$count] : ($regexflag[$count] = "no data"));
		if ($regexflag[$count] ne "regex"){
			$findlist[$count] = quotemeta($findlist[$count]);
			$count++;
		}
		else {$count++;next;}
	}
	
}

#テキスト・バイナリ判別サブルーチン
sub is_text{
	my $file = $_[0];
	my ($guess,$buf);
	open FH,$file or die("$file");
	#ファイルを開いて200バイト読み込み、(短過ぎると失敗する) その後、文字コードの判別
	read (FH, $buf,200);
	close FH;
	$guess = Encode::Guess::guess_encoding($buf);
	unless(ref $guess){$nottext_count++;return 0;}
	#文字コードの判別に成功しても下記の文字コード以外はバイナリと見なす。
	elsif ($guess->name =~ m/^(ascii|utf8|UTF-16|shiftjis|euc-jp|7bit-jis|)$/){return 1;}
	else{$nottext_count++;return 0;}
}